(defun c:MLeaderWBlTxt_BL( / tagname ensel entsel obj obj1 obj2 tag tagname Val1 att ent ML ppp)
(vl-load-com)   
(setvar "CMDECHO" 0)
(setq temperr *error*);;store *error*
(setq *error* trap1);;re-assign *error*

(setvar "ATTDIA" 0)
(setvar "ATTREQ" 0)

   (initget "ORDER QUANTITY ITEMDESCRIPTION ITEMDESCRIPTIONHEB")
   (if (null (setq tagname (getkword "\nChoose Attribute To Show [ORDER/QUANTITY/ITEMDESCRIPTION/ITEMDESCRIPTIONHEB] <ITEMDESCRIPTION>: ")))
      (setq tagname "ITEM_DESCRIPTION")
   )
 
   (if (= tagname "ITEMDESCRIPTION") (setq tagname "ITEM_DESCRIPTION"))

 (while 1
   (setq ensel (entsel "\nSelect Block: ")) ;select the block object to copy

   (setq obj1 (car ensel)) ;set the block object to varaible
   (setq obj2 (vlax-ename->vla-object obj1)) ;; set the pipe object to a VLAX object for the attribute rotation function

   (setq tag (strcase tagname))
   (setq Val1 (vl-some '(lambda ( att ) (if (= tag (strcase (vla-get-tagstring att))) (vla-get-textstring att))) (vlax-invoke obj2 'getattributes)))
   (princ val1)
   (command "_mleader" pause pause)


   ;;(princ entlast)
   (setq ML (vlax-ename->vla-object (entlast))) ;; set the Mleader object to a VLAX object for the LM:setmleaderblockattributevalue function
   (princ ML)

;; Set MLeader Block Attribute Value  -  Lee Mac
;; mld - [vla] MLeader object with attributed block content
;; tag - [str] Attribute tag whose value will be modified
;; val - [str] New attribute value

;;(defun LM:setmleaderblockattributevalue ( mld tag val )
   (if (= acblockcontent (vla-get-contenttype ML))
       (vl-catch-all-error-p
           (vl-catch-all-apply
              '(lambda ( / oid )
                   (vlax-for obj
                       (vla-item
                           (vla-get-blocks (vla-get-document ML))
                           (vla-get-contentblockname ML)
                       )
                       (if (and (= "AcDbAttributeDefinition" (vla-get-objectname obj))
                                (= :vlax-false (vla-get-constant obj))
                                (= "ITEM" (strcase (vla-get-tagstring obj)))
                           )
                           (progn
                               (if (vlax-property-available-p obj 'objectid32)
                                   (setq oid (vla-get-objectid32 obj))
                                   (setq oid (vla-get-objectid   obj))
                               )
                               (if (vlax-method-applicable-p ML 'setblockattributevalue32)
                                   (vla-setblockattributevalue32 ML oid val1)
                                   (vla-setblockattributevalue   ML oid val1)
                               )
                               (exit)
                           )
                       )
                   )
               )
           )
       )
   )
;;)

   
 );end while 
(setvar "CMDECHO" 1)
(princ)
);; end c:MLeaderWBlTxt_BL


(defun trap1 (errmsg)					;define function
(command "cmdecho" 0)
;;(setvar "ATTDIA" 1)
;;(setvar "ATTREQ" 1)
(vla-endundomark doc)

	(setq *error* temperr)				;restore *error*
	(prompt "\nResetting System Variables ")
(setvar "CMDECHO" 1)
   (princ)
)



;; Set Attribute Value  -  Lee Mac
;; Sets the value of the first attribute with the given tag found within the block, if present.
;; blk - [ent] Block (Insert) Entity Name
;; tag - [str] Attribute TagString
;; val - [str] Attribute Value
;; Returns: [str] Attribute value if successful, else nil.

(defun LM:setattributevalue ( blk tag val / enx )
    (if (and (setq blk (entnext blk)) (= "ATTRIB" (cdr (assoc 0 (setq enx (entget blk))))))
        (if (= (strcase tag) (strcase (cdr (assoc 2 enx))))
            (if (entmod (subst (cons 1 val) (assoc 1 (reverse enx)) enx))
                (progn
                    (entupd blk)
                    val
                )
            )
            (LM:setattributevalue blk tag val)
        )
    )
)

;; Set MLeader Block Attribute Value  -  Lee Mac
;; mld - [vla] MLeader object with attributed block content
;; tag - [str] Attribute tag whose value will be modified
;; val - [str] New attribute value

(defun LM:setmleaderblockattributevalue ( mld tag val )
   (if (= acblockcontent (vla-get-contenttype mld))
       (vl-catch-all-error-p
           (vl-catch-all-apply
              '(lambda ( / oid )
                   (vlax-for obj
                       (vla-item
                           (vla-get-blocks (vla-get-document mld))
                           (vla-get-contentblockname mld)
                       )
                       (if (and (= "AcDbAttributeDefinition" (vla-get-objectname obj))
                                (= :vlax-false (vla-get-constant obj))
                                (= (strcase tag) (strcase (vla-get-tagstring obj)))
                           )
                           (progn
                               (if (vlax-property-available-p obj 'objectid32)
                                   (setq oid (vla-get-objectid32 obj))
                                   (setq oid (vla-get-objectid   obj))
                               )
                               (if (vlax-method-applicable-p mld 'setblockattributevalue32)
                                   (vla-setblockattributevalue32 mld oid val)
                                   (vla-setblockattributevalue   mld oid val)
                               )
                               (exit)
                           )
                       )
                   )
               )
           )
       )
   )
(princ)
)

